UIPackage
Menu

Framework

Change language

Boilerplate repo

Sidebar

sidebarui

Full-height app sidebar — collapsible to icons, with grouping, sub-grouping, and integrated search. The navigation surface for product apps with many sections.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/sidebar.json
Named registry:npx shadcn@latest add @uipkge-react/sidebarInstalls to:components/ui/sidebar/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
variant
'default''outline'
defaultoptional
size
'default''sm''lg'
defaultoptional
defaultOpenbooleantrueoptional
openbooleanoptional
onOpenChange(open: boolean) => voidoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SidebarContextValue
type SidebarContextValue {
  state: 'expanded' | 'collapsed'
  open: boolean
  setOpen: (value: boolean) => void
  isMobile: boolean
  openMobile: boolean
  setOpenMobile: (value: boolean) => void
  toggleSidebar: () => void
}

Used by

Files installed (3)

  • components/ui/sidebar/sidebar.tsx27 kB
    'use client'
    
    import * as React from 'react'
    import { Slot } from '@radix-ui/react-slot'
    import { PanelLeft } from 'lucide-react'
    import { cn } from '@/lib/utils'
    import { Button } from '@/components/ui/button'
    import { Input } from '@/components/ui/input'
    import { Separator } from '@/components/ui/separator'
    import { Sheet, SheetContent, SheetHeader, SheetTitle, SheetDescription } from '@/components/ui/sheet'
    import { Skeleton } from '@/components/ui/skeleton'
    import { Tooltip, TooltipContent, TooltipProvider, TooltipTrigger } from '@/components/ui/tooltip'
    import { sidebarMenuButtonVariants } from './sidebar.variants'
    
    /* ------------------------------------------------------------------ */
    /* Constants (ported from utils.ts)                                    */
    /* ------------------------------------------------------------------ */
    
    const SIDEBAR_COOKIE_NAME = 'sidebar_state'
    const SIDEBAR_COOKIE_MAX_AGE = 60 * 60 * 24 * 7
    const SIDEBAR_WIDTH = '16rem'
    const SIDEBAR_WIDTH_MOBILE = '18rem'
    const SIDEBAR_WIDTH_ICON = '3rem'
    const SIDEBAR_KEYBOARD_SHORTCUT = 'b'
    
    /* ------------------------------------------------------------------ */
    /* Context (React equivalent of reka-ui's provide/inject)              */
    /* ------------------------------------------------------------------ */
    
    type SidebarContextValue = {
      state: 'expanded' | 'collapsed'
      open: boolean
      setOpen: (value: boolean) => void
      isMobile: boolean
      openMobile: boolean
      setOpenMobile: (value: boolean) => void
      toggleSidebar: () => void
    }
    
    const SidebarContext = React.createContext<SidebarContextValue | null>(null)
    
    function useSidebar() {
      const context = React.useContext(SidebarContext)
      if (!context) {
        throw new Error('useSidebar must be used within a SidebarProvider.')
      }
      return context
    }
    
    /* ------------------------------------------------------------------ */
    /* SidebarProvider                                                     */
    /* ------------------------------------------------------------------ */
    
    export interface SidebarProviderProps extends React.ComponentProps<'div'> {
      defaultOpen?: boolean
      open?: boolean
      onOpenChange?: (open: boolean) => void
    }
    
    const SidebarProvider = React.forwardRef<HTMLDivElement, SidebarProviderProps>(
      ({ defaultOpen = true, open: openProp, onOpenChange, className, style, children, ...props }, ref) => {
        // `useMediaQuery` returns `false` during SSR (no matchMedia) and
        // re-evaluates on the client's first effect. If the viewport is < 768px,
        // SSR HTML has the desktop branch but the client wants the mobile <Sheet>
        // branch -- React throws a hydration mismatch and the Sheet renders
        // without its overlay (the desktop sidebar's div is the parent the diff
        // lands against).
        //
        // Gating on `mounted` makes both the server and the client's first render
        // produce the desktop branch unconditionally; the effect then flips the
        // flag and `Sidebar`'s mobile branch re-runs against the real matchMedia
        // signal. Cost: a brief desktop-layout flash for mobile users on first
        // paint. That's the universal tradeoff for SSR-without-viewport-detection
        // -- there is no clean way to know the viewport on the server.
        const [mounted, setMounted] = React.useState(false)
        const [mediaMobile, setMediaMobile] = React.useState(false)
    
        React.useEffect(() => {
          setMounted(true)
          const mql = window.matchMedia('(max-width: 768px)')
          const onChange = () => setMediaMobile(mql.matches)
          onChange()
          mql.addEventListener('change', onChange)
          return () => mql.removeEventListener('change', onChange)
        }, [])
    
        const isMobile = mounted && mediaMobile
        const [openMobile, setOpenMobile] = React.useState(false)
    
        // Internal open state with optional controlled prop, mirroring the Vue
        // provider's plain ref (it defaulted to `true`).
        const [internalOpen, setInternalOpen] = React.useState(openProp ?? defaultOpen ?? true)
        const open = openProp ?? internalOpen
    
        const setOpen = React.useCallback(
          (value: boolean) => {
            if (onOpenChange) onOpenChange(value)
            else setInternalOpen(value)
    
            // This sets the cookie to keep the sidebar state.
            document.cookie = `${SIDEBAR_COOKIE_NAME}=${value}; path=/; max-age=${SIDEBAR_COOKIE_MAX_AGE}`
          },
          [onOpenChange],
        )
    
        // Helper to toggle the sidebar.
        const toggleSidebar = React.useCallback(() => {
          return isMobile ? setOpenMobile((v) => !v) : setOpen(!open)
        }, [isMobile, open, setOpen])
    
        React.useEffect(() => {
          const handler = (event: KeyboardEvent) => {
            if (event.key === SIDEBAR_KEYBOARD_SHORTCUT && (event.metaKey || event.ctrlKey)) {
              event.preventDefault()
              toggleSidebar()
            }
          }
          window.addEventListener('keydown', handler)
          return () => window.removeEventListener('keydown', handler)
        }, [toggleSidebar])
    
        // We add a state so that we can do data-state="expanded" or "collapsed".
        // This makes it easier to style the sidebar with Tailwind classes.
        const state = open ? 'expanded' : 'collapsed'
    
        const contextValue = React.useMemo<SidebarContextValue>(
          () => ({ state, open, setOpen, isMobile, openMobile, setOpenMobile, toggleSidebar }),
          [state, open, setOpen, isMobile, openMobile, toggleSidebar],
        )
    
        return (
          <SidebarContext.Provider value={contextValue}>
            <TooltipProvider delayDuration={0}>
              <div
                ref={ref}
                data-uipkge=""
                data-slot="sidebar-wrapper"
                style={
                  {
                    '--sidebar-width': SIDEBAR_WIDTH,
                    '--sidebar-width-icon': SIDEBAR_WIDTH_ICON,
                    ...style,
                  } as React.CSSProperties
                }
                className={cn('group/sidebar-wrapper has-data-[variant=inset]:bg-sidebar flex min-h-svh w-full', className)}
                {...props}
              >
                {children}
              </div>
            </TooltipProvider>
          </SidebarContext.Provider>
        )
      },
    )
    SidebarProvider.displayName = 'SidebarProvider'
    
    /* ------------------------------------------------------------------ */
    /* Sidebar                                                             */
    /* ------------------------------------------------------------------ */
    
    export interface SidebarProps extends React.ComponentProps<'div'> {
      side?: 'left' | 'right'
      variant?: 'sidebar' | 'floating' | 'inset'
      collapsible?: 'offcanvas' | 'icon' | 'none'
    }
    
    const Sidebar = React.forwardRef<HTMLDivElement, SidebarProps>(
      ({ side = 'left', variant = 'sidebar', collapsible = 'offcanvas', className, children, ...props }, ref) => {
        const { isMobile, state, openMobile, setOpenMobile } = useSidebar()
    
        if (collapsible === 'none') {
          return (
            <div
              ref={ref}
              data-uipkge=""
              data-slot="sidebar"
              className={cn('bg-sidebar text-sidebar-foreground flex h-full w-(--sidebar-width) flex-col', className)}
              {...props}
            >
              {children}
            </div>
          )
        }
    
        if (isMobile) {
          return (
            <Sheet open={openMobile} onOpenChange={setOpenMobile} {...props}>
              <SheetContent
                data-sidebar="sidebar"
                data-uipkge=""
                data-slot="sidebar"
                data-mobile="true"
                side={side}
                className="bg-sidebar text-sidebar-foreground w-(--sidebar-width) p-0 [&>button]:hidden"
                style={
                  {
                    '--sidebar-width': SIDEBAR_WIDTH_MOBILE,
                  } as React.CSSProperties
                }
              >
                <SheetHeader className="sr-only">
                  <SheetTitle>Sidebar</SheetTitle>
                  <SheetDescription>Displays the mobile sidebar.</SheetDescription>
                </SheetHeader>
                <div className="flex h-full w-full flex-col">{children}</div>
              </SheetContent>
            </Sheet>
          )
        }
    
        return (
          <div
            ref={ref}
            className="group peer text-sidebar-foreground hidden md:block"
            data-uipkge=""
            data-slot="sidebar"
            data-state={state}
            data-collapsible={state === 'collapsed' ? collapsible : ''}
            data-variant={variant}
            data-side={side}
          >
            {/* This is what handles the sidebar gap on desktop  */}
            <div
              className={cn(
                'relative w-(--sidebar-width) bg-transparent transition-[width] duration-200 ease-linear',
                'group-data-[collapsible=offcanvas]:w-0',
                'group-data-[side=right]:rotate-180',
                variant === 'floating' || variant === 'inset'
                  ? 'group-data-[collapsible=icon]:w-[calc(var(--sidebar-width-icon)+(--spacing(4)))]'
                  : 'group-data-[collapsible=icon]:w-(--sidebar-width-icon)',
              )}
            />
            <div
              className={cn(
                'fixed inset-y-0 z-10 hidden h-svh w-(--sidebar-width) transition-[left,right,width] duration-200 ease-linear md:flex',
                side === 'left'
                  ? 'left-0 group-data-[collapsible=offcanvas]:left-[calc(var(--sidebar-width)*-1)]'
                  : 'right-0 group-data-[collapsible=offcanvas]:right-[calc(var(--sidebar-width)*-1)]',
                // Adjust the padding for floating and inset variants.
                variant === 'floating' || variant === 'inset'
                  ? 'p-2 group-data-[collapsible=icon]:w-[calc(var(--sidebar-width-icon)+(--spacing(4))+2px)]'
                  : 'group-data-[collapsible=icon]:w-(--sidebar-width-icon) group-data-[side=left]:border-r group-data-[side=right]:border-l',
                className,
              )}
              {...props}
            >
              <div
                data-sidebar="sidebar"
                className="bg-sidebar group-data-[variant=floating]:border-sidebar-border flex h-full w-full flex-col group-data-[variant=floating]:rounded-lg group-data-[variant=floating]:border group-data-[variant=floating]:shadow-sm"
              >
                {children}
              </div>
            </div>
          </div>
        )
      },
    )
    Sidebar.displayName = 'Sidebar'
    
    /* ------------------------------------------------------------------ */
    /* SidebarTrigger                                                      */
    /* ------------------------------------------------------------------ */
    
    const SidebarTrigger = React.forwardRef<React.ElementRef<typeof Button>, React.ComponentProps<typeof Button>>(
      ({ className, onClick, ...props }, ref) => {
        const { toggleSidebar } = useSidebar()
    
        return (
          <Button
            ref={ref}
            data-sidebar="trigger"
            data-uipkge=""
            data-slot="sidebar-trigger"
            variant="ghost"
            size="icon"
            className={cn('focus-visible:ring-ring h-7 w-7 focus-visible:ring-2 focus-visible:outline-none', className)}
            onClick={(event) => {
              onClick?.(event)
              toggleSidebar()
            }}
            {...props}
          >
            <PanelLeft />
            <span className="sr-only">Toggle Sidebar</span>
          </Button>
        )
      },
    )
    SidebarTrigger.displayName = 'SidebarTrigger'
    
    /* ------------------------------------------------------------------ */
    /* SidebarRail                                                         */
    /* ------------------------------------------------------------------ */
    
    const SidebarRail = React.forwardRef<HTMLButtonElement, React.ComponentProps<'button'>>(
      ({ className, ...props }, ref) => {
        const { toggleSidebar } = useSidebar()
    
        return (
          <button
            ref={ref}
            type="button"
            data-sidebar="rail"
            data-uipkge=""
            data-slot="sidebar-rail"
            aria-label="Toggle Sidebar"
            tabIndex={-1}
            title="Toggle Sidebar"
            className={cn(
              'hover:after:bg-sidebar-border focus-visible:ring-ring absolute inset-y-0 z-20 hidden w-4 -translate-x-1/2 transition-colors duration-200 ease-linear group-data-[side=left]:-right-4 group-data-[side=right]:left-0 after:absolute after:inset-y-0 after:left-1/2 after:w-[2px] focus-visible:ring-2 focus-visible:outline-none sm:flex',
              'in-data-[side=left]:cursor-w-resize in-data-[side=right]:cursor-e-resize',
              '[[data-side=left][data-state=collapsed]_&]:cursor-e-resize [[data-side=right][data-state=collapsed]_&]:cursor-w-resize',
              'hover:group-data-[collapsible=offcanvas]:bg-sidebar group-data-[collapsible=offcanvas]:translate-x-0 group-data-[collapsible=offcanvas]:after:left-full',
              '[[data-side=left][data-collapsible=offcanvas]_&]:-right-2',
              '[[data-side=right][data-collapsible=offcanvas]_&]:-left-2',
              className,
            )}
            onClick={toggleSidebar}
            {...props}
          />
        )
      },
    )
    SidebarRail.displayName = 'SidebarRail'
    
    /* ------------------------------------------------------------------ */
    /* SidebarInset                                                        */
    /* ------------------------------------------------------------------ */
    
    const SidebarInset = React.forwardRef<HTMLElement, React.ComponentProps<'main'>>(({ className, ...props }, ref) => (
      <main
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-inset"
        className={cn(
          // min-w-0 is load-bearing: a flex-1 child without it inherits min-width: auto,
          // which means any single wide descendant (chart, table, code block) blows the
          // inset's width past its grid track. The upstream shadcn-ui sidebar omits this.
          'bg-background relative flex w-full min-w-0 flex-1 flex-col',
          'md:peer-data-[variant=inset]:m-2 md:peer-data-[variant=inset]:ml-0 md:peer-data-[variant=inset]:rounded-xl md:peer-data-[variant=inset]:shadow-sm md:peer-data-[variant=inset]:peer-data-[state=collapsed]:ml-2',
          className,
        )}
        {...props}
      />
    ))
    SidebarInset.displayName = 'SidebarInset'
    
    /* ------------------------------------------------------------------ */
    /* SidebarInput                                                        */
    /* ------------------------------------------------------------------ */
    
    const SidebarInput = React.forwardRef<React.ElementRef<typeof Input>, React.ComponentProps<typeof Input>>(
      ({ className, ...props }, ref) => (
        // Sidebar-tuned wrapper over the kit's <Input>.
        <Input
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-input"
          data-sidebar="input"
          className={cn('bg-background h-8 w-full shadow-none', className)}
          {...props}
        />
      ),
    )
    SidebarInput.displayName = 'SidebarInput'
    
    /* ------------------------------------------------------------------ */
    /* SidebarHeader / SidebarFooter                                       */
    /* ------------------------------------------------------------------ */
    
    const SidebarHeader = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'>>(({ className, ...props }, ref) => (
      <div
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-header"
        data-sidebar="header"
        className={cn('flex flex-col gap-2 p-2', className)}
        {...props}
      />
    ))
    SidebarHeader.displayName = 'SidebarHeader'
    
    const SidebarFooter = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'>>(({ className, ...props }, ref) => (
      <div
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-footer"
        data-sidebar="footer"
        className={cn('flex flex-col gap-2 p-2', className)}
        {...props}
      />
    ))
    SidebarFooter.displayName = 'SidebarFooter'
    
    /* ------------------------------------------------------------------ */
    /* SidebarSeparator                                                    */
    /* ------------------------------------------------------------------ */
    
    const SidebarSeparator = React.forwardRef<React.ElementRef<typeof Separator>, React.ComponentProps<typeof Separator>>(
      ({ className, ...props }, ref) => (
        <Separator
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-separator"
          data-sidebar="separator"
          className={cn('bg-sidebar-border mx-2 w-auto', className)}
          {...props}
        />
      ),
    )
    SidebarSeparator.displayName = 'SidebarSeparator'
    
    /* ------------------------------------------------------------------ */
    /* SidebarContent                                                      */
    /* ------------------------------------------------------------------ */
    
    const SidebarContent = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'>>(({ className, ...props }, ref) => (
      <div
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-content"
        data-sidebar="content"
        className={cn(
          'flex min-h-0 flex-1 flex-col gap-2 overflow-auto group-data-[collapsible=icon]:overflow-hidden',
          className,
        )}
        {...props}
      />
    ))
    SidebarContent.displayName = 'SidebarContent'
    
    /* ------------------------------------------------------------------ */
    /* SidebarGroup family                                                 */
    /* ------------------------------------------------------------------ */
    
    const SidebarGroup = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'>>(({ className, ...props }, ref) => (
      <div
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-group"
        data-sidebar="group"
        className={cn('relative flex w-full min-w-0 flex-col p-2', className)}
        {...props}
      />
    ))
    SidebarGroup.displayName = 'SidebarGroup'
    
    const SidebarGroupLabel = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'> & { asChild?: boolean }>(
      ({ className, asChild = false, ...props }, ref) => {
        const Comp = asChild ? Slot : 'div'
    
        return (
          <Comp
            ref={ref}
            data-uipkge=""
            data-slot="sidebar-group-label"
            data-sidebar="group-label"
            className={cn(
              'text-sidebar-foreground/70 ring-sidebar-ring mt-2 mb-1 flex h-8 shrink-0 items-center rounded-md px-2 text-xs font-medium outline-hidden transition-[margin,opacity] duration-200 ease-linear focus-visible:ring-2 [&>svg]:size-4 [&>svg]:shrink-0',
              'group-data-[collapsible=icon]:-mt-8 group-data-[collapsible=icon]:opacity-0',
              className,
            )}
            {...props}
          />
        )
      },
    )
    SidebarGroupLabel.displayName = 'SidebarGroupLabel'
    
    const SidebarGroupAction = React.forwardRef<HTMLButtonElement, React.ComponentProps<'button'> & { asChild?: boolean }>(
      ({ className, asChild = false, ...props }, ref) => {
        const Comp = asChild ? Slot : 'button'
    
        return (
          <Comp
            ref={ref}
            data-uipkge=""
            data-slot="sidebar-group-action"
            data-sidebar="group-action"
            className={cn(
              'text-sidebar-foreground ring-sidebar-ring hover:bg-sidebar-accent hover:text-sidebar-accent-foreground absolute top-3.5 right-3 flex aspect-square w-5 items-center justify-center rounded-md p-0 outline-hidden transition-transform focus-visible:ring-2 [&>svg]:size-4 [&>svg]:shrink-0',
              'after:absolute after:-inset-2 md:after:hidden',
              'group-data-[collapsible=icon]:hidden',
              className,
            )}
            {...props}
          />
        )
      },
    )
    SidebarGroupAction.displayName = 'SidebarGroupAction'
    
    const SidebarGroupContent = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'>>(
      ({ className, ...props }, ref) => (
        <div
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-group-content"
          data-sidebar="group-content"
          className={cn('w-full text-sm', className)}
          {...props}
        />
      ),
    )
    SidebarGroupContent.displayName = 'SidebarGroupContent'
    
    /* ------------------------------------------------------------------ */
    /* SidebarMenu family                                                  */
    /* ------------------------------------------------------------------ */
    
    const SidebarMenu = React.forwardRef<HTMLUListElement, React.ComponentProps<'ul'>>(({ className, ...props }, ref) => (
      <ul
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-menu"
        data-sidebar="menu"
        className={cn('flex w-full min-w-0 flex-col gap-1', className)}
        {...props}
      />
    ))
    SidebarMenu.displayName = 'SidebarMenu'
    
    const SidebarMenuItem = React.forwardRef<HTMLLIElement, React.ComponentProps<'li'>>(({ className, ...props }, ref) => (
      <li
        ref={ref}
        data-uipkge=""
        data-slot="sidebar-menu-item"
        data-sidebar="menu-item"
        className={cn('group/menu-item relative', className)}
        {...props}
      />
    ))
    SidebarMenuItem.displayName = 'SidebarMenuItem'
    
    export interface SidebarMenuButtonProps extends React.ComponentProps<'button'> {
      asChild?: boolean
      isActive?: boolean
      variant?: 'default' | 'outline'
      size?: 'default' | 'sm' | 'lg'
      tooltip?: string | React.ReactNode | React.ComponentProps<typeof TooltipContent>
    }
    
    const SidebarMenuButton = React.forwardRef<HTMLButtonElement, SidebarMenuButtonProps>(
      ({ asChild = false, isActive = false, variant = 'default', size = 'default', tooltip, className, ...props }, ref) => {
        const Comp = asChild ? Slot : 'button'
        const { isMobile, state } = useSidebar()
    
        const button = (
          <Comp
            ref={ref}
            data-uipkge=""
            data-slot="sidebar-menu-button"
            data-sidebar="menu-button"
            data-size={size}
            data-active={isActive}
            className={cn(sidebarMenuButtonVariants({ variant, size }), className)}
            {...props}
          />
        )
    
        if (!tooltip) {
          return button
        }
    
        let tooltipProps: React.ComponentProps<typeof TooltipContent>
        if (typeof tooltip === 'string') {
          tooltipProps = { children: tooltip }
        } else if (React.isValidElement(tooltip)) {
          tooltipProps = { children: tooltip }
        } else {
          tooltipProps = tooltip as React.ComponentProps<typeof TooltipContent>
        }
    
        return (
          <Tooltip>
            <TooltipTrigger asChild>{button}</TooltipTrigger>
            <TooltipContent side="right" align="center" hidden={state !== 'collapsed' || isMobile} {...tooltipProps} />
          </Tooltip>
        )
      },
    )
    SidebarMenuButton.displayName = 'SidebarMenuButton'
    
    const SidebarMenuAction = React.forwardRef<
      HTMLButtonElement,
      React.ComponentProps<'button'> & { asChild?: boolean; showOnHover?: boolean }
    >(({ className, asChild = false, showOnHover = false, ...props }, ref) => {
      const Comp = asChild ? Slot : 'button'
    
      return (
        <Comp
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-menu-action"
          data-sidebar="menu-action"
          className={cn(
            'text-sidebar-foreground ring-sidebar-ring hover:bg-sidebar-accent hover:text-sidebar-accent-foreground peer-hover/menu-button:text-sidebar-accent-foreground absolute top-1.5 right-1 flex aspect-square w-5 items-center justify-center rounded-md p-0 outline-hidden transition-transform focus-visible:ring-2 [&>svg]:size-4 [&>svg]:shrink-0',
            'after:absolute after:-inset-2 md:after:hidden',
            'peer-data-[size=sm]/menu-button:top-1',
            'peer-data-[size=default]/menu-button:top-1.5',
            'peer-data-[size=lg]/menu-button:top-2.5',
            'group-data-[collapsible=icon]:hidden',
            showOnHover &&
              'peer-data-[active=true]/menu-button:text-sidebar-accent-foreground group-focus-within/menu-item:opacity-100 group-hover/menu-item:opacity-100 data-[state=open]:opacity-100 md:opacity-0',
            className,
          )}
          {...props}
        />
      )
    })
    SidebarMenuAction.displayName = 'SidebarMenuAction'
    
    const SidebarMenuBadge = React.forwardRef<HTMLDivElement, React.ComponentProps<'div'>>(
      ({ className, ...props }, ref) => (
        <div
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-menu-badge"
          data-sidebar="menu-badge"
          className={cn(
            'text-sidebar-foreground pointer-events-none absolute right-1 flex h-5 min-w-5 items-center justify-center rounded-md px-1 text-xs font-medium tabular-nums select-none',
            'peer-hover/menu-button:text-sidebar-accent-foreground peer-data-[active=true]/menu-button:text-sidebar-accent-foreground',
            'peer-data-[size=sm]/menu-button:top-1',
            'peer-data-[size=default]/menu-button:top-1.5',
            'peer-data-[size=lg]/menu-button:top-2.5',
            'group-data-[collapsible=icon]:hidden',
            className,
          )}
          {...props}
        />
      ),
    )
    SidebarMenuBadge.displayName = 'SidebarMenuBadge'
    
    const SidebarMenuSkeleton = React.forwardRef<
      HTMLDivElement,
      React.ComponentProps<'div'> & { showIcon?: boolean; width?: string }
    >(({ className, showIcon = false, width = '70%', ...props }, ref) => {
      return (
        <div
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-menu-skeleton"
          data-sidebar="menu-skeleton"
          className={cn('flex h-8 items-center gap-2 rounded-md px-2', className)}
          {...props}
        >
          {showIcon && <Skeleton className="size-4 rounded-md" data-sidebar="menu-skeleton-icon" />}
    
          <Skeleton
            className="h-4 max-w-(--skeleton-width) flex-1"
            data-sidebar="menu-skeleton-text"
            style={{ '--skeleton-width': width } as React.CSSProperties}
          />
        </div>
      )
    })
    SidebarMenuSkeleton.displayName = 'SidebarMenuSkeleton'
    
    const SidebarMenuSub = React.forwardRef<HTMLUListElement, React.ComponentProps<'ul'>>(
      ({ className, ...props }, ref) => (
        <ul
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-menu-sub"
          data-sidebar="menu-badge"
          className={cn(
            'border-sidebar-border mx-3.5 flex min-w-0 translate-x-px flex-col gap-1 border-l px-2.5 py-0.5',
            'group-data-[collapsible=icon]:hidden',
            className,
          )}
          {...props}
        />
      ),
    )
    SidebarMenuSub.displayName = 'SidebarMenuSub'
    
    const SidebarMenuSubItem = React.forwardRef<HTMLLIElement, React.ComponentProps<'li'>>(
      ({ className, ...props }, ref) => (
        <li
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-menu-sub-item"
          data-sidebar="menu-sub-item"
          className={cn('group/menu-sub-item relative', className)}
          {...props}
        />
      ),
    )
    SidebarMenuSubItem.displayName = 'SidebarMenuSubItem'
    
    const SidebarMenuSubButton = React.forwardRef<
      HTMLAnchorElement,
      React.ComponentProps<'a'> & { asChild?: boolean; size?: 'sm' | 'md'; isActive?: boolean }
    >(({ asChild = false, size = 'md', isActive = false, className, ...props }, ref) => {
      const Comp = asChild ? Slot : 'a'
    
      return (
        <Comp
          ref={ref}
          data-uipkge=""
          data-slot="sidebar-menu-sub-button"
          data-sidebar="menu-sub-button"
          data-size={size}
          data-active={isActive}
          className={cn(
            'text-sidebar-foreground ring-sidebar-ring hover:bg-sidebar-accent hover:text-sidebar-accent-foreground active:bg-sidebar-accent active:text-sidebar-accent-foreground [&>svg]:text-sidebar-accent-foreground flex h-7 min-w-0 -translate-x-px items-center gap-2 overflow-hidden rounded-md px-2 outline-hidden focus-visible:ring-2 disabled:pointer-events-none disabled:opacity-50 aria-disabled:pointer-events-none aria-disabled:opacity-50 [&>span:last-child]:truncate [&>svg]:size-4 [&>svg]:shrink-0',
            'data-[active=true]:bg-sidebar-accent data-[active=true]:text-sidebar-accent-foreground',
            size === 'sm' && 'text-xs',
            size === 'md' && 'text-sm',
            'group-data-[collapsible=icon]:hidden',
            className,
          )}
          {...props}
        />
      )
    })
    SidebarMenuSubButton.displayName = 'SidebarMenuSubButton'
    
    export {
      Sidebar,
      SidebarContent,
      SidebarFooter,
      SidebarGroup,
      SidebarGroupAction,
      SidebarGroupContent,
      SidebarGroupLabel,
      SidebarHeader,
      SidebarInput,
      SidebarInset,
      SidebarMenu,
      SidebarMenuAction,
      SidebarMenuBadge,
      SidebarMenuButton,
      SidebarMenuItem,
      SidebarMenuSkeleton,
      SidebarMenuSub,
      SidebarMenuSubButton,
      SidebarMenuSubItem,
      SidebarProvider,
      SidebarRail,
      SidebarSeparator,
      SidebarTrigger,
      useSidebar,
    }
    
  • components/ui/sidebar/sidebar.variants.ts1.9 kB
  • components/ui/sidebar/index.ts0.8 kB

Raw manifest:https://uipkge.dev/r/react/sidebar.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Sidebar

sidebarui

Full-height app sidebar — collapsible to icons, with grouping, sub-grouping, and integrated search. The navigation surface for product apps with many sections.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/sidebar.json
Named registry:npx shadcn-vue@latest add @uipkge/sidebarInstalls to:app/components/ui/sidebar/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
variant
'default''outline'
defaultoptional
size
'default''sm''lg'
defaultoptional

Used by

Files installed (27)

  • app/components/ui/sidebar/Sidebar.vue3.9 kB
    <script setup lang="ts">
    import type { SidebarProps } from '.'
    import { cn } from '@/lib/utils'
    import { Sheet, SheetContent } from '@/components/ui/sheet'
    import SheetDescription from '@/components/ui/sheet/SheetDescription.vue'
    import SheetHeader from '@/components/ui/sheet/SheetHeader.vue'
    import SheetTitle from '@/components/ui/sheet/SheetTitle.vue'
    import { SIDEBAR_WIDTH_MOBILE, useSidebar } from './utils'
    
    defineOptions({
      inheritAttrs: false,
    })
    
    const props = withDefaults(defineProps<SidebarProps>(), {
      side: 'left',
      variant: 'sidebar',
      collapsible: 'offcanvas',
    })
    
    const { isMobile, state, openMobile, setOpenMobile } = useSidebar()
    </script>
    
    <template>
      <div
        v-if="collapsible === 'none'"
        data-uipkge
        data-slot="sidebar"
        :class="cn('bg-sidebar text-sidebar-foreground flex h-full w-(--sidebar-width) flex-col', props.class)"
        v-bind="$attrs"
      >
        <slot />
      </div>
    
      <Sheet v-else-if="isMobile" :open="openMobile" v-bind="$attrs" @update:open="setOpenMobile">
        <SheetContent
          data-sidebar="sidebar"
          data-uipkge
          data-slot="sidebar"
          data-mobile="true"
          :side="side"
          class="bg-sidebar text-sidebar-foreground w-(--sidebar-width) p-0 [&>button]:hidden"
          :style="{
            '--sidebar-width': SIDEBAR_WIDTH_MOBILE,
          }"
        >
          <SheetHeader class="sr-only">
            <SheetTitle>Sidebar</SheetTitle>
            <SheetDescription>Displays the mobile sidebar.</SheetDescription>
          </SheetHeader>
          <div class="flex h-full w-full flex-col">
            <slot />
          </div>
        </SheetContent>
      </Sheet>
    
      <div
        v-else
        class="group peer text-sidebar-foreground hidden md:block"
        data-uipkge
        data-slot="sidebar"
        :data-state="state"
        :data-collapsible="state === 'collapsed' ? collapsible : ''"
        :data-variant="variant"
        :data-side="side"
      >
        <!-- This is what handles the sidebar gap on desktop  -->
        <div
          :class="
            cn(
              'relative w-(--sidebar-width) bg-transparent transition-[width] duration-200 ease-linear',
              'group-data-[collapsible=offcanvas]:w-0',
              'group-data-[side=right]:rotate-180',
              variant === 'floating' || variant === 'inset'
                ? 'group-data-[collapsible=icon]:w-[calc(var(--sidebar-width-icon)+(--spacing(4)))]'
                : 'group-data-[collapsible=icon]:w-(--sidebar-width-icon)',
            )
          "
        />
        <div
          :class="
            cn(
              'fixed inset-y-0 z-10 hidden h-svh w-(--sidebar-width) transition-[left,right,width] duration-200 ease-linear md:flex',
              side === 'left'
                ? 'left-0 group-data-[collapsible=offcanvas]:left-[calc(var(--sidebar-width)*-1)]'
                : 'right-0 group-data-[collapsible=offcanvas]:right-[calc(var(--sidebar-width)*-1)]',
              // Adjust the padding for floating and inset variants (token-aligned with React/shadcn).
              variant === 'floating' || variant === 'inset'
                ? 'p-2 group-data-[collapsible=icon]:w-[calc(var(--sidebar-width-icon)+(--spacing(4))+2px)]'
                : 'group-data-[collapsible=icon]:w-(--sidebar-width-icon) group-data-[side=left]:border-r group-data-[side=right]:border-l',
              props.class,
            )
          "
          v-bind="$attrs"
        >
          <div
            data-sidebar="sidebar"
            class="bg-sidebar group-data-[variant=floating]:border-sidebar-border flex h-full w-full flex-col group-data-[variant=floating]:rounded-lg group-data-[variant=floating]:border group-data-[variant=floating]:shadow-sm"
          >
            <slot />
          </div>
        </div>
      </div>
    </template>
    
    <style>
    /* Push any OverlayScroll thumb inside a sidebar 2.5rem in from the right
       edge so it clears SidebarRail's inside-zone. The CSS variable
       cascades to every descendant, so consumers wrapping their nav in
       OverlayScroll (a common pattern when nav items overflow viewport
       height) get this for free -- no per-call thumb-offset config. */
    [data-slot='sidebar'] {
      --ovs-thumb-right: 2.5rem;
    }
    </style>
    
  • app/components/ui/sidebar/SidebarContent.vue0.4 kB
  • app/components/ui/sidebar/SidebarFooter.vue0.3 kB
  • app/components/ui/sidebar/SidebarGroup.vue0.4 kB
  • app/components/ui/sidebar/SidebarGroupAction.vue0.9 kB
  • app/components/ui/sidebar/SidebarGroupContent.vue0.4 kB
  • app/components/ui/sidebar/SidebarGroupLabel.vue0.9 kB
  • app/components/ui/sidebar/SidebarHeader.vue0.3 kB
  • app/components/ui/sidebar/SidebarInput.vue0.7 kB
  • app/components/ui/sidebar/SidebarInset.vue0.9 kB
  • app/components/ui/sidebar/SidebarMenu.vue0.4 kB
  • app/components/ui/sidebar/SidebarMenuAction.vue1.4 kB
  • app/components/ui/sidebar/SidebarMenuBadge.vue0.9 kB
  • app/components/ui/sidebar/SidebarMenuButton.vue1.3 kB
  • app/components/ui/sidebar/SidebarMenuButtonChild.vue1.3 kB
  • app/components/ui/sidebar/SidebarMenuItem.vue0.4 kB
  • app/components/ui/sidebar/SidebarMenuSkeleton.vue0.8 kB
  • app/components/ui/sidebar/SidebarMenuSub.vue0.5 kB
  • app/components/ui/sidebar/SidebarMenuSubButton.vue1.4 kB
  • app/components/ui/sidebar/SidebarMenuSubItem.vue0.4 kB
  • app/components/ui/sidebar/SidebarProvider.vue3.2 kB
  • app/components/ui/sidebar/SidebarRail.vue1.4 kB
  • app/components/ui/sidebar/SidebarSeparator.vue0.4 kB
  • app/components/ui/sidebar/SidebarTrigger.vue0.7 kB
  • app/components/ui/sidebar/sidebar.variants.ts1.9 kB
  • app/components/ui/sidebar/index.ts2 kB
  • app/components/ui/sidebar/utils.ts0.7 kB

Raw manifest:https://uipkge.dev/r/vue/sidebar.json